<bugID>718608<Summary>Migration code shrink and cleanup: unified code for notifications and error handling, prepare for deCOM</Summary><Description>Created attachment 589155
wip

In bug 710259, I started writing a shared module for migration. I'm moving the work on it to this bug.

Goals:
1. Unify migration notifications handling.
2. Do away with error-prone error-handling in each migrator (at least in sync cases).
3. Prepare for deCOMing migrators (bug 718280)
3.1. Prepare for broken and unused "profiles" support from migrators api.
4. Shrink migrators code.
5. General cleanup of Firefox and Chrome migrators.
6. Basic tests for the new module</Description></bugID>